//PROGRAMM FOR BUTTON AND LED
//
// PROCESSOR : PIC18LF8490
// CLOCK	 : 20MHz, EXTERNAL

#include <pic18.h>

// Configuration bit
__CONFIG(1, HS & FCMDIS & IESODIS) ;
__CONFIG(2, PWRTDIS & WDTDIS & BORDIS & BORV20) ;
__CONFIG(3, CCP2RC1 & LPT1DIS & MCLRDIS) ;
__CONFIG(4, XINSTEN & STVREN) ;
__CONFIG(5, UNPROTECT) ;

#define TONE_1		1
#define TONE_2		2
#define TONE_3		3

#define	BIT0	0x01
#define	BIT1	0x02
#define	BIT2	0x04
#define	BIT3	0x08
#define	BIT4	0x10
#define	BIT5	0x20
#define	BIT6	0x40
#define	BIT7	0x80


//Just simple delay
// simple delay ~mS
void Delay_mS(unsigned long a) { 
	 a *= 370;
	while (--a!=0); 
}

// simple delay ~100us
void Delay_100uS(unsigned long a) { 
	 a *= 37;
	while (--a!=0); 
}

// BUZZER -------------------------------------------
// Init buzzer
void InitBuzzer(void) {
	
	// buzzer as output
	TRISC &= ~BIT2; 

	// buzzer pin to low
	PORTC &= ~BIT2; 

}

// Beep ~2Khz
void Beep(char dly) {

	PORTC &= ~BIT2; 
	Delay_100uS(dly);
	PORTC |= BIT2; 
	Delay_100uS(dly);	
}


// Init Buttons
void InitButtons(void) {
	
	// Center button is on port -> input
	TRISB |= (BIT0|BIT3|BIT4);
}


// main function
void main( void ) {


	INTCON 	= 0x0; 	 	// disable interupt

	// Init Buzzer
	InitBuzzer();

	// Init Buttons
	InitButtons();
	
	// loop forever 
	while(1) {

		// if Button B1 is pressed
		if((PORTB & BIT3)==0) { Beep(TONE_1); }

		// if Button B2 is pressed
		if((PORTB & BIT4)==0) { Beep(TONE_2); }

		// if Button B3 is pressed
		if((PORTB & BIT0)==0) { Beep(TONE_3); }

	}
}
